'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.yomoReact = exports.ViewException = exports.yomoView = exports.Provider = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _reactLoader = require('react-loader');

var _reactLoader2 = _interopRequireDefault(_reactLoader);

var _withContext = require('recompose/withContext');

var _withContext2 = _interopRequireDefault(_withContext);

var _getContext = require('recompose/getContext');

var _getContext2 = _interopRequireDefault(_getContext);

var _mobxReact = require('mobx-react');

var _myExceptions = require('../util/my-exceptions.js');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Provider = exports.Provider = (0, _withContext2.default)({
  yomo: _react2.default.PropTypes.func,
  store: _react2.default.PropTypes.object
}, function (props) {
  return { yomo: props.yomo, store: props.store };
})(function (_ref) {
  var children = _ref.children;
  return _react2.default.createElement(
    'div',
    null,
    children
  );
});

var yomoView = exports.yomoView = function yomoView(View, options) {
  return (0, _mobxReact.observer)((0, _getContext2.default)({ yomo: _react2.default.PropTypes.func })(function (props) {
    try {
      return View(props);
    } catch (exception) {
      var waiting = (0, _myExceptions.isWaitX)(exception);
      var V = props.yomo.ViewException || ViewException;
      return _react2.default.createElement(V, { waiting: waiting, exception: exception, options: options });
    }
  }));
};

var ViewException = exports.ViewException = yomoView(function (_ref2) {
  var waiting = _ref2.waiting;
  var exception = _ref2.exception;

  if (waiting) {
    var speed = waiting > 0 ? 1 : 0;
    return _react2.default.createElement(
      'span',
      { style: {
          position: 'relative', display: 'block', height: '2em'
        } },
      _react2.default.createElement(_reactLoader2.default, { options: { scale: 0.8, speed: speed } })
    );
  } else {
    console.log(exception);
    return null;
  }
});

var yomoReact = exports.yomoReact = {
  render: function render(_ref3, yomo) {
    var View = _ref3.View;
    var domId = _ref3.domId;
    return View && _reactDom2.default.render(_react2.default.createElement(
      Provider,
      { yomo: yomo },
      _react2.default.createElement(View, null)
    ), document.getElementById(domId || 'root'));
  }
};